#ifndef CSO_H__
#define CSO_H__

/* non-interlock critical section object */
#if 0
int sample()
{
	static CRITICAL_SECTION_OBJECT(var);
	if (CRITICAL_SECTION_ENTER(var))
	{
		/* +--------------------+ */
		/* |  critical section  | */
		/* +--------------------+ */
		CRITICAL_SECTION_LEAVE(var);
	}
}
int sample2()
{
	static CRITICAL_SECTION_OBJECT(var);
	while (!CRITICAL_SECTION_ENTER(var)) sleep();
	/* +--------------------+ */
	/* |  critical section  | */
	/* +--------------------+ */
	CRITICAL_SECTION_LEAVE(var);
}
#endif


#ifdef _WIN32

/* critical section object (WIN32) */
#include <windows.h>
#define CRITICAL_SECTION_OBJECT(a)	LONG a = 1
#define CRITICAL_SECTION_ENTER(a)	(1 == InterlockedExchange((LPLONG)&a, 0))
#define CRITICAL_SECTION_LEAVE(a)	InterlockedExchange((LPLONG)&a, 1)
#define CRITICAL_SECTION_MEMBER(a)	LONG a
#define CRITICAL_SECTION_INIT(a)	a = 1

#else

/* critical section object (ANSI-C) */
#define CRITICAL_SECTION_OBJECT(a)	volatile int a = 0
#define CRITICAL_SECTION_ENTER(a)	((0 == a++) || (--a, 0))
#define CRITICAL_SECTION_LEAVE(a)	{ (--a); }
#define CRITICAL_SECTION_MEMBER(a)	volatile int a
#define CRITICAL_SECTION_INIT(a)	a = 0

#endif

#endif /* CSO_H__ */
